/*
 * Copyright (c) 2011 by Axway Software
 * All brand or product names are trademarks or registered trademarks
 * of their respective holders.
 * This document and the software described in this document are the property
 * of Axway Software and are protected as Axway Software trade secrets.
 * No part of this work may be reproduced or disseminated in any form or
 * by any means, without the prior written permission of Axway Software.
 */

package com.acme.upload;

import java.util.concurrent.BlockingQueue;

/**
 *
 * @author dgay
 */
public class UploadExecutor implements Runnable
{
    //private BlockingQueue<Upload>   queue;
    private BlockingQueue<Upload> queue;
    
    public UploadExecutor( BlockingQueue<Upload> queue )
    {
        this.queue = queue;
    }

    @Override
    public void run()
    {
        Upload  upload;

        while( true )
        {
            try
            {
                upload = queue.take();
                if( !upload.upload() )
                {
                    queue.put( upload );
                }
                else
                {
                    //System.out.println( "Finish : "+upload );
                }
            }
            catch( Exception ex )
            {
                ex.printStackTrace( System.err );
            }
        }
    }


}
